- Main Page
- Related Pages
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | List of all members
SignOn::IdentityInfo Class Reference

Contains identity information. More...

`#include <SignOn/IdentityInfo>`

## Public Types
enum | CredentialsType { Other = 0, Application = 1 << 0, Web = 1 << 1, Network = 1 << 2 }
| Values used to describe the type of the identity. More...

## Public Member Functions
| IdentityInfo ()
| Creates a new empty IdentityInfo object.
| IdentityInfo (const IdentityInfo &other)
| Copy constructor.
IdentityInfo & | operator= (const IdentityInfo &other)
| Assignment operator.
| IdentityInfo (const QString &caption, const QString &userName, const QMap< MethodName, MechanismsList > &methods)
| Creates a new IdentityInfo object with given values. More...
| ~IdentityInfo ()
| Destructor.
void | setId (const quint32 id)
| Sets the numeric identifier for the credentials record. More...
quint32 | id () const
| Returns the identity identifier. More...
void | setSecret (const QString &secret, const bool storeSecret=true)
| Sets the secret. More...
QString | secret () const
| Gets the secret. More...
bool | isStoringSecret () const
| Returns whether secret is to be stored. More...
void | setStoreSecret (const bool storeSecret)
| Sets whether the secret is stored or not. More...
void | setUserName (const QString &userName)
| Sets the username. More...
const QString | userName () const
| Returns the username. More...
void | setCaption (const QString &caption)
| Sets a human readable caption of the identity. More...
const QString | caption () const
| Returns a human-readable representation of the identity. More...
void | setRealms (const QStringList &realms)
| Sets the realms, e.g. More...
QStringList | realms () const
| Gets the realms, e.g. More...
void | setOwner (const QString &ownerToken)
| Sets application token that owns identity, therefore defining the applications that will be able to modify this specific set of credentials. More...
QString | owner () const
| Gets the owner application token that is defining the applications that are able to modify this specific set of credentials. More...
void | setAccessControlList (const QStringList &accessControlList)
| Sets the list of access control application tokens, therefore defining the applications that will be able to access this specific set of credentials. More...
QStringList | accessControlList () const
| Gets the list of access control application tokens defining the applications that are able to access this specific set of credentials. More...
void | setMethod (const MethodName &method, const MechanismsList &mechanismsList)
| Sets the method into identity info. More...
void | removeMethod (const MethodName &method)
| Removes a method from identity info. More...
void | setType (CredentialsType type)
| Sets the type into identity info. More...
CredentialsType | type () const
| Retrieves the identity type from identity info. More...
QList< MethodName > | methods () const
| Lists all methods in identity info. More...
MechanismsList | mechanisms (const MethodName &method) const
| Lists the all mechanisms for certain method in identity info. More...
void | setRefCount (qint32 refCount)
| Sets the refcount into identity info. More...
qint32 | refCount () const
| Retrieves the refcount from identity info. More...

## Detailed Description

Contains identity information.

This information is stored into database.

See Also
  queryIdentities()

Definition at line 57 of file identityinfo.h.

## Member Enumeration Documentation

enum SignOn::IdentityInfo::CredentialsType

Values used to describe the type of the identity.

Attention
  Mixed types, i.e Application|Web are not yet supported. Just single types work for the time being.

Definition at line 69 of file identityinfo.h.

## Constructor & Destructor Documentation

SignOn::IdentityInfo::IdentityInfo | ( | const QString & | caption,
|  | const QString & | userName,
|  | const QMap< MethodName, MechanismsList > & | methods
| ) |  |

Creates a new IdentityInfo object with given values.

Parameters

  caption | Description of identity
  userName | Username
  methods | Allowed methods for identity

Definition at line 58 of file identityinfo.cpp.

References caption(), methods(), and userName().

## Member Function Documentation

QStringList SignOn::IdentityInfo::accessControlList | ( |  | ) | const

Gets the list of access control application tokens defining the applications that are able to access this specific set of credentials.

Attention
  This is accessible only to the owner application.

Returns
  The access control tokens which defines the applications allowed to access this set of credentials.

Definition at line 133 of file identityinfo.cpp.

Referenced by setAccessControlList().

const QString SignOn::IdentityInfo::caption | ( |  | ) | const

Returns a human-readable representation of the identity.

Returns
  Human-readable representation of the identity.

Definition at line 102 of file identityinfo.cpp.

Referenced by IdentityInfo(), and setCaption().

quint32 SignOn::IdentityInfo::id | ( |  | ) | const

Returns the identity identifier.

Returns
  Identifier for the identity

Definition at line 80 of file identityinfo.cpp.

Referenced by setId().

bool SignOn::IdentityInfo::isStoringSecret | ( |  | ) | const

Returns whether secret is to be stored.

Returns
  true Whether the secret is being stored or not.

Definition at line 150 of file identityinfo.cpp.

MechanismsList SignOn::IdentityInfo::mechanisms | ( | const MethodName & | method | ) | const

Lists the all mechanisms for certain method in identity info.

Parameters

  method | Method name to list mechanisms

Returns
  List of mechanisms

Definition at line 189 of file identityinfo.cpp.

QList< MethodName > SignOn::IdentityInfo::methods | ( |  | ) | const

Lists all methods in identity info.

Returns
  Param method method name to remove.

Definition at line 184 of file identityinfo.cpp.

Referenced by IdentityInfo().

QString SignOn::IdentityInfo::owner | ( |  | ) | const

Gets the owner application token that is defining the applications that are able to modify this specific set of credentials.

Attention
  This is accessible only to the owner application.

Returns
  The access control token which defines the applications allowed to modify this set of credentials.

Definition at line 122 of file identityinfo.cpp.

QStringList SignOn::IdentityInfo::realms | ( |  | ) | const

Gets the realms, e.g.

URL's with which the Identity using this IdentityInfo works with.

Returns
  List of supported realms.

Definition at line 112 of file identityinfo.cpp.

Referenced by setRealms().

qint32 SignOn::IdentityInfo::refCount | ( |  | ) | const

Retrieves the refcount from identity info.

Returns
  Refcount for this IdentityInfo

Definition at line 199 of file identityinfo.cpp.

void SignOn::IdentityInfo::removeMethod | ( | const MethodName & | method | ) |

Removes a method from identity info.

Parameters

  method | Method name to remove

Definition at line 169 of file identityinfo.cpp.

QString SignOn::IdentityInfo::secret | ( |  | ) | const

Gets the secret.

If this object was retrieved from the database, the returned secret might be an empty string.

Returns
  The secret, when allowed, or an empty string.

Definition at line 138 of file identityinfo.cpp.

Referenced by setSecret().

void SignOn::IdentityInfo::setAccessControlList | ( | const QStringList & | accessControlList | ) |

Sets the list of access control application tokens, therefore defining the applications that will be able to access this specific set of credentials.

Parameters

  accessControlList | List of access control tokens

Definition at line 127 of file identityinfo.cpp.

References accessControlList().

void SignOn::IdentityInfo::setCaption | ( | const QString & | caption | ) |

Sets a human readable caption of the identity.

Parameters

  caption | Caption

Definition at line 96 of file identityinfo.cpp.

References caption().

void SignOn::IdentityInfo::setId | ( | const quint32 | id | ) |

Sets the numeric identifier for the credentials record.

Calling this method makes only sense when handling the Identity::credentialsStored() signal.

Parameters

  id | The numeric identifier of the credentials.

Definition at line 75 of file identityinfo.cpp.

References id().

void SignOn::IdentityInfo::setMethod | ( | const MethodName & | method,
|  | const MechanismsList & | mechanismsList
| ) |  |

Sets the method into identity info.

If the given method is not included, a new one will be added. If it is already set, the mechanism list assosiated to it is updated. an empty list will clear the mechanisms. These values are used to limit Identity to use the specified methods and mechanisms.

Parameters

  method | Method name to change
  mechanismsList | list of mechanisms that are allowed

Definition at line 160 of file identityinfo.cpp.

void SignOn::IdentityInfo::setOwner | ( | const QString & | ownerToken | ) |

Sets application token that owns identity, therefore defining the applications that will be able to modify this specific set of credentials.

Parameters

  ownerToken | owner token

Definition at line 117 of file identityinfo.cpp.

void SignOn::IdentityInfo::setRealms | ( | const QStringList & | realms | ) |

Sets the realms, e.g.

URL's with which the Identity using this IdentityInfo shall work with.

Parameters

  realms | List of the realms to be set.

Definition at line 107 of file identityinfo.cpp.

References realms().

void SignOn::IdentityInfo::setRefCount | ( | qint32 | refCount | ) |

Sets the refcount into identity info.

The type is used to generically identify where this identity is being used.

Note
  Server can restrict changes to differ +-1 from previous.

Parameters

  refCount | Set refcount

Definition at line 194 of file identityinfo.cpp.

void SignOn::IdentityInfo::setSecret | ( | const QString & | secret,
|  | const bool | storeSecret = `true`
| ) |  |

Sets the secret.

When performing a challenge on the owner Identity object, if the secret is set on its corresponding IdentityInfo, it will be added to the parameter list that is passed to the corresponding authentication plugin challenge implementation. By default a newly created IdentityInfo does not contain a secret and has a policy of not storing any. If the secret is set the default policy will be to store it. This behaviour can also be set with IdentityInfo::setStoreSecret().

See Also
  PluginInterface::secretKey
  PluginInterface::challenge

Parameters

  secret |
  storeSecret | Whether the secret is stored or not

Definition at line 143 of file identityinfo.cpp.

References secret().

void SignOn::IdentityInfo::setStoreSecret | ( | const bool | storeSecret | ) |

Sets whether the secret is stored or not.

Parameters

  storeSecret | Whether the secret must be stored in the DB.

Definition at line 155 of file identityinfo.cpp.

void SignOn::IdentityInfo::setType | ( | IdentityInfo::CredentialsType | type | ) |

Sets the type into identity info.

The type is used to generically identify where this identity is being used.

Attention
  If this method is not called, the IdentityInfo type will default to SignOn::OtherIdentity.

Parameters

  type | Type we want to assign to this IdentityInfo

Definition at line 174 of file identityinfo.cpp.

void SignOn::IdentityInfo::setUserName | ( | const QString & | userName | ) |

Sets the username.

See Also
  userNameKey

Parameters

  userName | Username

Definition at line 85 of file identityinfo.cpp.

References userName().

IdentityInfo::CredentialsType SignOn::IdentityInfo::type | ( |  | ) | const

Retrieves the identity type from identity info.

Returns
  The identity type for this IdentityInfo

Definition at line 179 of file identityinfo.cpp.

const QString SignOn::IdentityInfo::userName | ( |  | ) | const

Returns the username.

Returns
  Username for the identity

Definition at line 91 of file identityinfo.cpp.

Referenced by IdentityInfo(), and setUserName().

The documentation for this class was generated from the following files:

- identityinfo.h
- identityinfo.cpp